﻿@page
@using Management.Entities;
@using Management.BusinessLogic;
@using Newtonsoft.Json;
@model Management.Pages.import.AddModel
@{
    /* Constants */
    ViewData["Title"] = "Add Import";

    /* Default value */
    string sInfoStorage = string.Empty;
    string sInfoImport = string.Empty;

    Import import = new Import() {};
    Storage storage = new Storage() {}; 
    Storage[] storageList = new Storage[0];

    string sStorageList = string.Empty;
    uint formId = 0;


    /* Get form data in case method is POST */
    if (Request.Method == "POST") 
    {
        /* Get the current list of storages as a string */
        sStorageList = Request.Form["storages"];
        BUS_Storage.StringToList(sStorageList, ref storageList);

        /* Processing based on Form ID */
        if (true == uint.TryParse(Request.Form["form"], out formId))
        {
            /* Form ID 1 - Submit order information */
            if (1 == formId)
            {
                /* Get import info */
                string sID = Request.Form["id"];
                string sUser = Request.Form["user"];
                string sDate = Request.Form["date"];

                /* Returns an empty string in case the new import order is successfully added */
                sInfoImport = BUS_Import.Add(sID, sUser, sDate, storageList, ref import);

                /* Clear form in case the new import order is successfully added  */
                if (string.IsNullOrEmpty(sInfoImport))
                {
                    import = new Import() { };
                    storage = new Storage() { };
                    storageList = new Storage[0];
                    sStorageList = string.Empty;
                }
            }

            /* Form ID 2 - Submit a storage data */
            else if (2 == formId)
            {
                /* Get storage data as string list */
                string sProductName = Request.Form["pname"];
                string sQuantity = Request.Form["quantity"];
                string sManufactureDate = Request.Form["mdate"];
                string sExpiryDate = Request.Form["edate"];

                /* Check storage valid */
                sInfoStorage = BUS_Storage.StringToImportStorage(sProductName, sQuantity, sManufactureDate, sExpiryDate, ref storage);

                /* Returns an empty string in case the storage is valid */
                if (string.IsNullOrEmpty(sInfoStorage))
                {
                    /* Add storage to storage list */
                    sInfoStorage = BUS_Storage.AddToList(storage, ref storageList);

                    /* Returns an empty string in case successful addition */
                    if (string.IsNullOrEmpty(sInfoStorage))
                    {
                        /* Get a list of new storages as a string to add values to an HTML form */
                        sStorageList = BUS_Storage.ToStringList(storageList);

                        /* Clear form in case the new storage is successfully added  */
                        storage = new Storage() { };
                    }
                }
            }
        }

        /* Final get storage list to display on table */
        BUS_Storage.StringToList(sStorageList, ref storageList);
    }
} 

<div class="row text-start">
    <p>
        <a href="/" class="link-primary text-decoration-none">Home</a>
        >
        <a href="/import" class="link-primary text-decoration-none">Import</a>
        >
        <a href="/import/add" class="link-primary text-decoration-none">Add</a>
    </p>
</div>
<div class="border border-secondary rounded px-3 mb-3">
    <div class="row pt-2">
        <p class="col-sm-6 text-start fw-bold">Order Header</p>
        @if (!string.IsNullOrEmpty(sInfoImport))
        {
            <p class="col-sm-6 text-end text-danger fw-bold">@sInfoImport</p>
        }
        else if (1 == formId)
        {
            <p class="col-sm-6 text-end text-success fw-bold">Added a new import order successfully</p>
        }
    </div>

    <!-- form ID 1 for submit Order information -->
    <form class="row g-3 mb-2" method="post">
        <input type="hidden" id="form" name="form" value="1">
        <input type="hidden" id="storages" name="storages" value="@sStorageList">
        <div class="col-md-3">
            <label for="id" class="form-label">Import ID</label>
            <input class="form-control" type="text" id="id" name="id" value="@import.ID" placeholder="Import ID" maxlength="30" required>
        </div>
        <div class="col-md-3">
            <label for="user" class="form-label">Import Name</label>
            <input class="form-control" type="text" id="user" name="user" value="@import.User" placeholder="Import User" maxlength="30" required>
        </div>
        <div class="col-md-3">
            <label for="date" class="form-label">Import Date</label>
            <input class="form-control" type="date" id="date" name="date" value="@import.Date" required>
        </div>
        <div class="col-md-3 d-sm-flex align-items-end justify-content-end pb-1">
            <input class="btn btn-sm btn-success text-light" type="submit" value="Import">
        </div>
    </form>
</div>

<div class="border border-secondary rounded px-3 mb-3">
    <div class="row pt-2">
        <p class="col-sm-6 text-start fw-bold">Record Data</p>
        @if (!string.IsNullOrEmpty(sInfoStorage))
        {
            <p class="col-sm-6 text-end text-danger fw-bold">@sInfoStorage</p>
        }
        else if (2 == formId)
        {
            <p class="col-sm-6 text-end text-success fw-bold">Added a new record successfully</p>
        }
    </div>

    <!-- form ID 2 for submit a Storage information -->
    <form class="row g-3 mb-2" method="post">
        <input type="hidden" id="form" name="form" value="2">
        <input type="hidden" id="storages" name="storages" value="@sStorageList">
        <div class="col-md-3">
            <label for="pname" class="form-label">Product Name</label>
            <input class="form-control" type="text" id="pname" name="pname" value="@storage.ProductName" placeholder="Product Name" maxlength="30" required>
        </div>
        <div class="col-md-3">
            <label for="quantity" class="form-label">Quantity</label>
            <input class="form-control" type="number" id="quantity" name="quantity" value="@storage.Quantity" min="1" required>
        </div>
        <div class="col-md-2">
            <label for="mdate" class="form-label">MFD</label>
            <input class="form-control" type="date" id="mdate" name="mdate" value="@storage.ManufactureDate" required>
        </div>
        <div class="col-md-2">
            <label for="edate" class="form-label">EXD</label>
            <input class="form-control" type="date" id="edate" name="edate" value="@storage.ExpiryDate" required>
        </div>
        <div class="col-md-2 d-sm-flex align-items-end justify-content-end pb-1">
            <input class="btn btn-sm btn-info text-light" type="submit" value="Add Record">
        </div>
    </form>
</div>

<div class="border border-secondary rounded px-3 mb-3">
    <div class="row pt-2">
        <p class="text-start fw-bold">Record Table</p>
    </div>
    <div class="text-center table_section">

        <table class="table table-bordered table-striped table-hover align-middle">
            <thead>
                <tr>
                    <th>No</th>
                    <th>Product Name</th>
                    <th>Quantity</th>
                    <th>MFD</th>
                    <th>EXD</th>
                </tr>
            </thead>

            <tbody>
                @if (storageList.Length > 0)
                {
                    uint j = 1;
                    for (uint i = 0; i < storageList.Length; i++)
                    {
                        <tr>
                            <td>@j</td>
                            <td>@storageList[i].ProductName</td>
                            <td>@storageList[i].Quantity</td>
                            <td>@storageList[i].ManufactureDate</td>
                            <td>@storageList[i].ExpiryDate</td>
                            <td>

                                <!-- form ID 3 for submit delete a storage  -->
                                <form method="post">
                                    <input type="hidden" id="form" name="form" value="3">
                                    <input type="hidden" id="storages" name="storages" value="@sStorageList">
                                    <input type="hidden" id="storages" name="storages" value="@storageList[i].ProductName">
                                    <input type="hidden" id="storages" name="storages" value="@storageList[i].Quantity">
                                    <input type="hidden" id="storages" name="storages" value="@storageList[i].ManufactureDate">
                                    <input type="hidden" id="storages" name="storages" value="@storageList[i].ExpiryDate">
                                </form>
                            </td>
                        </tr>
                        j++;
                    }
                }
                else
                {
                    <tr>
                        <td colspan="7" class="text-center fw-bold">No data available</td>
                    </tr>
                }
            </tbody>
        </table>
    </div>
</div>
